load('large_network.mat')

% Part b)
L = L'; % Uncomment this for part d)
alpha = 0.15;
m = size(L,1);
B = zeros(m,m);
B(:,:) = 1/m;

num_outgoing_links = sum(L,2); % Calculate number of outgoing links from each node
prob_outgoing_links = zeros(m,1); % Calculate prob assigned to each outgoing link, for each node
for i=1:m
    if num_outgoing_links(i) > 0
        prob_outgoing_links(i) = 1/num_outgoing_links(i);
    else
        prob_outgoing_links(i) = 0;
    end      
end
T = L .* prob_outgoing_links;

for i = 1:m
    if sum(T(i,:)) == 0
        T(i,i) = 1;
    end
end
G = ((1-alpha) .* T) + (alpha .* B); % Google Matrix

% Part c)
pi_0 = zeros(1,m);
pi_0(:) = 1/m;
n = 100;
prob_vectors = zeros(n,m); % Stores probability vectors at each time step
absolute_changes = zeros(1,n); % Stores absolute changes between consecutive time steps
for i=1:n
    if i==1
        pi_prev = pi_0;
    else
        pi_prev = prob_vectors(i-1,:);
    end
    pi_i = pi_prev * G;
    prob_vectors(i,:) = pi_i;
    e = sum(abs(pi_i - pi_prev));
    absolute_changes(i) = e;
end
plot(absolute_changes)
stationary_distribution = prob_vectors(n,:);
[sorted_dist, ranks] = sort(stationary_distribution,'descend');
top_25_ranks = ranks(1:25);
top_25_probs = sorted_dist(1:25);
top_25_websites = names(top_25_ranks);

% Part d)
% Simply transpose L and then run lines 4-49 on this new transposed matrix.
